{$if not def EXEC_EXECBASE_H} CONST EXEC_EXECBASE_H=0;

{ *****************************************************************
  ** KickPascal-Include-Datei "exec/execbase.h" zu Kickstart 3.0 **
  ***************************************************************** }

TYPE p_ExecBase = ^ExecBase;


{$if not def EXEC_LISTS_H;incl "exec/lists.h";endif}
{$if not def EXEC_INTERRUPTS_H;incl "exec/interrupts.h";endif}
{$if not def EXEC_LIBRARIES_H;incl "exec/libraries.h";endif}
{$if not def EXEC_TASKS_H;incl "exec/tasks.h";endif}

TYPE ExecBase = RECORD
 LibNode      : _Library;
 SoftVer      : Word;
 LowMemChkSum : Integer;
 ChkBase      : Long;
 ColdCapture  : Ptr;
 CoolCapture  : Ptr;
 WarmCapture  : Ptr;
 SysStkUpper  : Ptr;
 SysStkLower  : Ptr;
 MaxLocMem    : Long;
 DebugEntry   : Ptr;
 DebugData    : Ptr;
 AlertData    : Ptr;
 MaxExtMem    : Ptr;
 ChkSum       : Word;

 IntVects     : ARRAY[0..15] OF IntVector;

 ThisTask     : p_Task;

 IdleCount    : Long;
 DispCount    : Long;
 Quantum      : Word;
 Elapsed      : Word;
 SysFlags     : Word;
 IDNestCnt    : Short;
 TDNestCnt    : Short;

 AttnFlags    : Word;

 AttnResched  : Word;
 ResModules   : Ptr;
 TaskTrapCode : Ptr;
 TaskExceptCode:Ptr;
 TaskExitCode : Ptr;
 TaskSigAlloc : Long;
 TaskTrapAlloc: Word;

 MemList      : List;
 ResourceList : List;
 DeviceList   : List;
 IntrList     : List;
 LibList      : List;
 PortList     : List;
 TaskReady    : List;
 TaskWait     : List;

 SoftInts     : ARRAY [0..4] OF SoftIntList;

 LastAlert    : ARRAY [0..3] OF Long;

 VBlankFrequency: Byte;
 PowerSupplyFrequency: Byte;

 SemaphoreList: List;
 KickMemPtr   : Ptr;
 KickTagPtr   : Ptr;
 KickCheckSum : Ptr;

{ *** ab V36 / Kickstart 2.0 *** }
 ex_Pad0      : Word;
 ex_Reserved0 : Long;
 ex_RamLibPrivate:Ptr;
 ex_EClockFrequency:Long;
 ex_CacheControl: Long;
 ex_TaskID    : Long;

 ex_Reserved1 : ARRAY[0..4] of Long;

 ex_MMULock   : Ptr;

 ex_Reserved2 : ARRAY[0..2] OF Long;
 ex_MemHandlers: MinList;
 ex_MemHandler: Ptr;
END;


CONST
 AFB_68010 = 0;
 AFB_68020 = 1;
 AFB_68030 = 2;
 AFB_68040 = 3;
 AFB_68881 = 4;
 AFB_68882 = 5;
 AFB_FPU40 = 6;

 AFB_PRIVATE=15;

 AFF_68010 = $1;
 AFF_68020 = $2;
 AFF_68030 = $4;
 AFF_68040 = $8;
 AFF_68881 = $10;
 AFF_68882 = $20;
 AFF_FPU40 = $40;
 
 AFF_PRIVATE= $8000

{ AFB_RESERVED8 = 8 }
{ AFB_RESERVED9 = 9 }


CONST
 CACRF_EnableI      = $1;
 CACRF_FreezeI      = $2;
 CACRF_ClearI       = $4;
 CACRF_IBE          = $8;
 CACRF_EnableD      = $100;
 CACRF_FreezeD      = $200;
 CACRF_ClearD       = $800;
 CACRF_DBE          = $1000;
 CACRF_WriteAllocate= $2000;
 CACRF_EnableE      = $40000000;
 CACRF_CopyBack     = $80000000;

CONST
 DMA_Continue   = $2;
 DMA_NoModify   = $4;

{$endif}
