{$if not def EXEC_MEMORY_H} CONST EXEC_MEMORY_H=0;

{ ***************************************************************
  ** KickPascal-Include-Datei "exec/memory.h" zu Kickstart 3.0 **
  *************************************************************** }

TYPE p_MemChunk = ^MemChunk;
TYPE p_MemHeader = ^MemHeader;
TYPE p_MemEntry = ^MemEntry;
TYPE p_MemList = ^MemList;
TYPE p_MemHandlerData = ^MemHandlerData;

{$if not def EXEC_NODES_H;incl "exec/nodes.h";endif}


TYPE MemChunk = RECORD
 mc_Next  : p_MemChunk;
 mc_Bytes : Long;
END;


TYPE MemHeader = RECORD
 mh_Node       : Node;
 mh_Attributes : Word;
 mh_First      : p_MemChunk;
 mh_Lower      : Ptr;
 mh_Upper      : Ptr;
 mh_Free       : Long;
END;


TYPE MemEntry = RECORD
 CASE boolean OF
 false : (
          meu_Reqs  : Long;
          me_Length : Long;
         );
 true  : (
          meu_Addr  : Ptr;
          meu_Length: Long;
         );
END;

{ Zur Information :
  me_Reqs = me_Un.meu_Reqs
  me_Addr = me_Un.meu_Addr
}


TYPE MemList = RECORD
 ml_Node       : Node;
 ml_NumEntries : Word;
 ml_ME         : array[0..1] of MemEntry; { Mte [0..0] sein, aber nicht mglich }
END;

CONST
 MEMF_ANY      = $0;
 MEMF_PUBLIC   = $1;
 MEMF_CHIP     = $2;
 MEMF_FAST     = $4;
 MEMF_LOCAL    = $100;
 MEMF_24BITDMA = $200;
 MEMF_KICK     = $400;

 MEMF_CLEAR    = $10000;
 MEMF_LARGEST  = $20000;
 MEMF_REVERSE  = $40000;
 MEMF_TOTAL    = $80000;

 MEMF_NO_EXPUNGE= $80000000; 

 MEM_BLOCKSIZE = 8;
 MEM_BLOCKMASK = (MEM_BLOCKSIZE-1);


TYPE
 MemHandlerData=RECORD
  memh_RequestSize : Long;
  memh_RequestFlags: Long;
  memh_Flags       : Long;
 end;
 
CONST
 MEM_DID_NOTHING = 0;
 MEM_ALL_DONE    =-1;
 MEM_TRY_AGAIN   = 1;

{$endif}
